unit _11ServerUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Mask, ScktComp;


const
  mGetInterval = 2;
  mSetInterval = 4;

type
  TClient = class(TObject)
    LowInt: integer;
    HighInt: integer;
    Connected: boolean;
    CSocket: TCustomWinSocket;
    constructor Create(LInt,HInt: integer; Socket: TCustomWinSocket);
  end;

  TF_Server = class(TForm)
    Server: TServerSocket;
    MaskEdit1: TMaskEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label4: TLabel;
    ProgBar: TProgressBar;
    Label5: TLabel;
    procedure ServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
    Clients: TList;
    LowPos, HighPos: integer;
    PrimeNum: array[0..MaxWord] of integer;
    PrimeCount: integer;
    function GetPrimeCount(HInt: integer): integer;
  end;

var
  F_Server: TF_Server;

implementation

{$R *.DFM}

function TF_Server.GetPrimeCount(HInt: integer): integer;
begin
  Result:=  0;
  while (Result < PrimeCount) and (PrimeNum[Result] < HInt) do Inc(Result);
end;

procedure SendInterval(LPos, HPos: integer; Socket: TCustomWinSocket);
var
  A: array[0..2] of integer;
begin
  A[0]:= mSetInterval;
  A[1]:= LPos;
  A[2]:= HPos;
  Socket.SendBuf(A,SizeOf(integer)*3);
end;

procedure TF_Server.ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  I: integer;
begin
  for I:= 1 to Clients.Count do
  with TClient(Clients.Items[I-1]) do
  if not Connected then
  begin
    SendInterval(LowInt,HighInt,Socket);
    CSocket:= Socket;
    exit;
  end;
  SendInterval(LowPos, LowPos + 999, Socket);
  Clients.Add(TClient.Create(LowPos,LowPos + 999, Socket));
  Inc(LowPos,999);
end;

procedure TF_Server.FormCreate(Sender: TObject);
begin
  Clients:= TList.Create;
  LowPos:= 0;
  HighPos:= MaxInt;
  Server.Open;
end;

constructor TClient.Create(LInt,HInt: integer; Socket: TCustomWinSocket);
begin
  LowInt:= LInt;
  HighInt:= HInt;
  Connected:= true;
end;

procedure TF_Server.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  Count: integer;
  A: array[0..500] of integer;
  HInt: integer;
begin
  Count:= Server.Socket.ReceiveLength;
  if Count = 0 then exit;
  Server.Socket.ReceiveBuf(A,Count);
  if A[0] = mGetInterval then
  begin
    HInt:= A[1];
    if LowPos > HInt then
    Server.Socket.SendBuf(PrimeNum,GetPrimeCount(HInt)*SizeOf(integer));
  end else
  if A[0] = mSetInterval then
  begin
    Move(A[1],PrimeNum[PrimeCount-1],Count div 4 -1);
    Inc(PrimeCount,Count div 4 - 1);
  end;
end;

procedure TF_Server.ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  I: integer;
begin
  for I:= 1 to Clients.Count do
  if TClient(Clients.Items[I-1]).CSocket = Socket then
  TClient(Clients.Items[I-1]).Connected:= false;
end;

end.
